=== debian/changelog ===
nrn-mod2c (0.9+git220919-2) unstable; urgency=medium

  * No-change upload (autobuild trigger)

 -- Matthias Klumpp <mak@debian.org>  Fri, 03 Feb 2023 12:54:36 +0100

nrn-mod2c (0.9+git220919-1) unstable; urgency=medium

  * Initial release, part of NEURON 0.9.x

 -- Matthias Klumpp <mak@debian.org>  Fri, 27 Jan 2023 20:54:50 +0100
