=== debian/control ===
Source: nrn-mod2c
Section: science
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Klumpp <mak@debian.org>
Build-Depends: bison,
               cmake,
               debhelper-compat (= 13),
               flex
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/BlueBrain/mod2c
Vcs-Git: https://salsa.debian.org/science-team/nrn-mod2c.git
Vcs-Browser: https://salsa.debian.org/science-team/nrn-mod2c

Package: nrn-mod2c
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: NMODL to C converter for CoreNEURON
 MOD2C is NMODL to C adapted for CoreNEURON simulator.
 .
 NMODl is a description language to specify a model for a physical
 neuron in terms of simultaneous nonlinear algebraic equations,
 differential equations, or kinetic schemes.
