=== debian/changelog ===
nrn-mod2c (8.2.2-1) unstable; urgency=medium

  * New upstream version 8.2.2
  * Bump standards version: No changes needed

 -- Matthias Klumpp <mak@debian.org>  Sun, 04 May 2025 22:12:46 +0200
