=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                cmake,
                debhelper-compat (= 13),
                flex
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/BlueBrain/mod2c
 Vcs-Git: https://salsa.debian.org/science-team/nrn-mod2c.git
