=== debian/watch ===
version=4

https://github.com/BlueBrain/mod2c/tags .*/@ANY_VERSION@\.tar\.gz
